using System;
using System.Runtime.InteropServices;
using System.Web.UI;
using System.Web;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Serialization;

using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.SharePoint.WebPartPages;

using System.DirectoryServices;


//´Dosboy Email:dosboy@sina.com д,Ҫд,뱣Ϣ.

namespace DosboyChangePassword
{
    [Guid("84a42f31-73d9-480c-9e34-ec647a21d605")]
    public class DosboyChangePassword : System.Web.UI.WebControls.WebParts.WebPart
    {
        public DosboyChangePassword()
        {
            this.ExportMode = WebPartExportMode.All;
        }

        Label lblTitle;

        Label lbloldPass;
        TextBox tboldPass;

        Label lblnewPass;
        TextBox tbnewPass;

        Label lblnewPass2;
        TextBox tbnewPass2;

        Label lblInfo;

        Button btOK;




        protected override void CreateChildControls()
        {
            this.ChildControlsCreated = true;
            this.Controls.Clear();

            lblTitle = new Label();
            lblTitle.ID = "lblTitle";
            lblTitle.Font.Bold = true;
            lblTitle.Text = Environment.UserName + " ޸룺";
            lblTitle.Attributes ["NxtLine"]="true";
            this.Controls.AddAt(0, lblTitle);

            lbloldPass = new Label();
            lbloldPass.ID = "lbloldPass";
            lbloldPass.Text = "ԭ룺";
            lbloldPass.Attributes["NxtLine"] = "false";
            this.Controls.AddAt(1, lbloldPass);

            tboldPass = new TextBox();
            tboldPass.ID = "tboldPass";
            tboldPass.TextMode = TextBoxMode.Password;
            tboldPass.Attributes["NxtLine"] ="true";
            this.Controls.AddAt(2, tboldPass);


            lblnewPass = new Label();
            lblnewPass.ID = "lblnewPass";
            lblnewPass.Text = "µ룺";
            lblnewPass.Attributes["NxtLine"] = "false";
            this.Controls.AddAt(3, lblnewPass);


            tbnewPass = new TextBox();
            tbnewPass.ID = "tbnewPass";
            tbnewPass.TextMode = TextBoxMode.Password;
            tbnewPass.Attributes["NxtLine"] = "true";
            this.Controls.AddAt(4, tbnewPass);

            lblnewPass2 = new Label();
            lblnewPass2.ID = "lblnewPass2";
            lblnewPass2.Text = "֤룺";
            lblnewPass2.Attributes["NxtLine"] = "false";
            this.Controls.AddAt(5, lblnewPass2);

            tbnewPass2 = new TextBox();
            tbnewPass2.ID = "tbnewPass2";
            tbnewPass2.Attributes["NxtLine"] = "true";
            tbnewPass2.TextMode = TextBoxMode.Password;
            this.Controls.AddAt(6, tbnewPass2);

            lblInfo = new Label();
            lblInfo.ID = "lblInfo";
            lblInfo.Text = "";
            lblInfo.Attributes["nxtLine"] = "true";
            this.Controls.AddAt(7, lblInfo);

            btOK = new Button();
            btOK.ID = "btOK";
            btOK.Text = "ȷ";
            btOK.Attributes["nxtLine"] = "true";
            btOK.Click += new EventHandler(onClick);
  
            this.Controls.AddAt(8, btOK);


            //base.CreateChildControls();
        }

        protected void onClick(object sender, EventArgs e)
        {
            lblInfo.Text = "";
            if (tbnewPass.Text != tbnewPass2.Text)
                lblInfo.Text = "벻һ£";
            else
            {
                if (Environment.MachineName == Environment.UserDomainName)
                {
                   // lblInfo.Text = ChangeLocalUserPassword(Environment.UserDomainName, Environment.UserName, tboldPass.Text, tbnewPass.Text, "", "");
                     SPSecurity.RunWithElevatedPrivileges(delegate(){lblInfo.Text = ChangeLocalUserPassword(Environment.MachineName , lblTitle.Text.Substring (0,lblTitle .Text .IndexOf (" ")) , tboldPass.Text, tbnewPass.Text, "", "");});
                }
                else
                {
                    lblInfo.Text = ChangeADUserPassword(Environment.UserDomainName, Environment.UserName, tboldPass.Text, tbnewPass.Text);


                }
            }


        }

        #region Ҫ

        public string ChangeADUserPassword(string DomainName, string UserName, string oldPass, string newPass)
        // ÷ChangeADUserPassword("HQ", "zhangyan", "12345", "23456")
        {
            try
            {
                string strLDAP = "LDAP://" + DomainName;

                string fullLoginName = DomainName + "\\" + UserName;

                using (DirectoryEntry objDE = new DirectoryEntry(strLDAP, DomainName + "\\" + UserName, oldPass))
                {
                    DirectorySearcher deSearcher = new DirectorySearcher(objDE);
                    deSearcher.Filter = "(&(objectClass=user)(sAMAccountName=" + UserName + "))";
                    DirectoryEntry usr = deSearcher.FindOne().GetDirectoryEntry();
                    usr.Invoke("ChangePassword", new Object[2] { oldPass, newPass });
                    usr.CommitChanges();
                }
                return ("û룬ɹ");
            }
            catch (Exception ex)
            {
                return ("ʧ,Ϣ:"+ ex.Message);
            }

        }




        public static string ChangeLocalUserPassword(string LocalHostName, string UserName, string oldPass, string newPass, string AdminName, string AdminPass)
        {
           
                try
                {
                   

                    DirectoryEntry AD = new DirectoryEntry("WinNT://" + LocalHostName + ",computer");
                    DirectoryEntry NewUser = AD.Children.Find(UserName);
                    NewUser.Invoke("SetPassword", new object[] {newPass });
                    NewUser.CommitChanges();
                    
                    return ("ı룬ɹ");

                }
                catch (Exception ex)
                {
                    return ("ʧ,Ϣ:"+ex.Message );
                }
           
        }



       

        #endregion



        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
            if (this.DesignMode ) 
            {
                this.EnsureChildControls();
            }
        }


        protected override void Render(HtmlTextWriter writer)
        {
            // TODO: add custom rendering code here.
            // writer.Write("Output HTML");

            foreach (WebControl wc in this.Controls)
            {
                wc.RenderControl(writer);
                if (wc.Attributes["nxtLine"] == "true")
                {
                    writer.WriteBreak(); writer.WriteBreak();
                }

            }
        }
    }
}
